final class IDN extends Ordered[IDN]

Internationalized domain name, as specified by RFC3490 and RFC5891.

This type models internationalized hostnames. An IDN provides unicode labels, a unicode string form, and an ASCII hostname form.

A well formed IDN consists of one or more labels separated by dots. Each label may contain unicode characters as long as the converted ASCII form meets the requirements of RFC1123 (e.g., 63 or fewer characters and no leading or trailing dash). A dot is represented as an ASCII period or one of the unicode dots: full stop, ideographic full stop, fullwidth full stop, halfwidth ideographic full stop.

The toString method returns the IDN in the form in which it was constructed. Sometimes it is useful to normalize the IDN -- converting all dots to an ASCII period and converting all labels to lowercase.

Note: equality and comparison of IDNs is case-sensitive. Consider comparing normalized toString values for a more lenient notion of equality.

Source
IDN.scala
Linear Supertypes
Ordered[IDN], Comparable[IDN], AnyRef, Any
Ordering
  1. Alphabetic
  2. By Inheritance
Inherited
  1. IDN
  2. Ordered
  3. Comparable
  4. AnyRef
  5. Any
Implicitly
  1. by orderingToOrdered
  2. by any2stringadd
  3. by StringFormat
  4. by Ensuring
  5. by ArrowAssoc
  1. Hide All
  2. Show All
Visibility
  1. Public
  2. All

Value Members

  1. final def !=(arg0: Any): Boolean
    Definition Classes
    AnyRef → Any
  2. final def ##(): Int
    Definition Classes
    AnyRef → Any
  3. def +(other: String): String
    Implicit
    This member is added by an implicit conversion from IDN to any2stringadd[IDN] performed by method any2stringadd in scala.Predef.
    Definition Classes
    any2stringadd
  4. def ->[B](y: B): (IDN, B)
    Implicit
    This member is added by an implicit conversion from IDN to ArrowAssoc[IDN] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
    ArrowAssoc
    Annotations
    @inline()
  5. def <(that: IDN): Boolean
    Definition Classes
    Ordered
  6. def <=(that: IDN): Boolean
    Definition Classes
    Ordered
  7. final def ==(arg0: Any): Boolean
    Definition Classes
    AnyRef → Any
  8. def >(that: IDN): Boolean
    Definition Classes
    Ordered
  9. def >=(that: IDN): Boolean
    Definition Classes
    Ordered
  10. final def asInstanceOf[T0]: T0
    Definition Classes
    Any
  11. def clone(): AnyRef
    Attributes
    protected[java.lang]
    Definition Classes
    AnyRef
    Annotations
    @native() @throws( ... )
  12. def compare(that: IDN): Int
    Definition Classes
    IDN → Ordered
  13. def compareTo(that: IDN): Int
    Definition Classes
    Ordered → Comparable
  14. def ensuring(cond: (IDN) ⇒ Boolean, msg: ⇒ Any): IDN
    Implicit
    This member is added by an implicit conversion from IDN to Ensuring[IDN] performed by method Ensuring in scala.Predef.
    Definition Classes
    Ensuring
  15. def ensuring(cond: (IDN) ⇒ Boolean): IDN
    Implicit
    This member is added by an implicit conversion from IDN to Ensuring[IDN] performed by method Ensuring in scala.Predef.
    Definition Classes
    Ensuring
  16. def ensuring(cond: Boolean, msg: ⇒ Any): IDN
    Implicit
    This member is added by an implicit conversion from IDN to Ensuring[IDN] performed by method Ensuring in scala.Predef.
    Definition Classes
    Ensuring
  17. def ensuring(cond: Boolean): IDN
    Implicit
    This member is added by an implicit conversion from IDN to Ensuring[IDN] performed by method Ensuring in scala.Predef.
    Definition Classes
    Ensuring
  18. final def eq(arg0: AnyRef): Boolean
    Definition Classes
    AnyRef
  19. def equals(other: Any): Boolean
    Definition Classes
    IDN → AnyRef → Any
  20. def finalize(): Unit
    Attributes
    protected[java.lang]
    Definition Classes
    AnyRef
    Annotations
    @throws( classOf[java.lang.Throwable] )
  21. def formatted(fmtstr: String): String
    Implicit
    This member is added by an implicit conversion from IDN to StringFormat[IDN] performed by method StringFormat in scala.Predef.
    Definition Classes
    StringFormat
    Annotations
    @inline()
  22. final def getClass(): Class[_]
    Definition Classes
    AnyRef → Any
    Annotations
    @native()
  23. def hashCode(): Int
    Definition Classes
    IDN → AnyRef → Any
  24. val hostname: Hostname
  25. final def isInstanceOf[T0]: Boolean
    Definition Classes
    Any
  26. val labels: NonEmptyList[Label]
  27. final def ne(arg0: AnyRef): Boolean
    Definition Classes
    AnyRef
  28. def normalized: IDN

    Converts this IDN to lower case and replaces dots with ASCII periods.

  29. final def notify(): Unit
    Definition Classes
    AnyRef
    Annotations
    @native()
  30. final def notifyAll(): Unit
    Definition Classes
    AnyRef
    Annotations
    @native()
  31. final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
    AnyRef
  32. val toString: String
    Definition Classes
    IDN → AnyRef → Any
  33. final def wait(): Unit
    Definition Classes
    AnyRef
    Annotations
    @throws( ... )
  34. final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
    AnyRef
    Annotations
    @throws( ... )
  35. final def wait(arg0: Long): Unit
    Definition Classes
    AnyRef
    Annotations
    @native() @throws( ... )
  36. def →[B](y: B): (IDN, B)
    Implicit
    This member is added by an implicit conversion from IDN to ArrowAssoc[IDN] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
    ArrowAssoc

Shadowed Implicit Value Members

  1. def <(that: IDN): Boolean
    Implicit
    This member is added by an implicit conversion from IDN to Ordered[IDN] performed by method orderingToOrdered in scala.math.Ordered.
    Shadowing
    This implicitly inherited member is shadowed by one or more members in this class.
    To access this member you can use a type ascription:
    (iDN: Ordered[IDN]).<(that)
    Definition Classes
    Ordered
  2. def <=(that: IDN): Boolean
    Implicit
    This member is added by an implicit conversion from IDN to Ordered[IDN] performed by method orderingToOrdered in scala.math.Ordered.
    Shadowing
    This implicitly inherited member is shadowed by one or more members in this class.
    To access this member you can use a type ascription:
    (iDN: Ordered[IDN]).<=(that)
    Definition Classes
    Ordered
  3. def >(that: IDN): Boolean
    Implicit
    This member is added by an implicit conversion from IDN to Ordered[IDN] performed by method orderingToOrdered in scala.math.Ordered.
    Shadowing
    This implicitly inherited member is shadowed by one or more members in this class.
    To access this member you can use a type ascription:
    (iDN: Ordered[IDN]).>(that)
    Definition Classes
    Ordered
  4. def >=(that: IDN): Boolean
    Implicit
    This member is added by an implicit conversion from IDN to Ordered[IDN] performed by method orderingToOrdered in scala.math.Ordered.
    Shadowing
    This implicitly inherited member is shadowed by one or more members in this class.
    To access this member you can use a type ascription:
    (iDN: Ordered[IDN]).>=(that)
    Definition Classes
    Ordered
  5. def compare(that: IDN): Int
    Implicit
    This member is added by an implicit conversion from IDN to Ordered[IDN] performed by method orderingToOrdered in scala.math.Ordered.
    Shadowing
    This implicitly inherited member is shadowed by one or more members in this class.
    To access this member you can use a type ascription:
    (iDN: Ordered[IDN]).compare(that)
    Definition Classes
    Ordered
  6. def compareTo(that: IDN): Int
    Implicit
    This member is added by an implicit conversion from IDN to Ordered[IDN] performed by method orderingToOrdered in scala.math.Ordered.
    Shadowing
    This implicitly inherited member is shadowed by one or more members in this class.
    To access this member you can use a type ascription:
    (iDN: Ordered[IDN]).compareTo(that)
    Definition Classes
    Ordered → Comparable

Inherited from Ordered[IDN]

Inherited from Comparable[IDN]

Inherited from AnyRef

Inherited from Any

Inherited by implicit conversion orderingToOrdered from IDN to Ordered[IDN]

Inherited by implicit conversion any2stringadd from IDN to any2stringadd[IDN]

Inherited by implicit conversion StringFormat from IDN to StringFormat[IDN]

Inherited by implicit conversion Ensuring from IDN to Ensuring[IDN]

Inherited by implicit conversion ArrowAssoc from IDN to ArrowAssoc[IDN]

Ungrouped